classification
Title: sdist refuses README.rst
Type: enhancement Stage: resolved
Components: Distutils Versions: Python 3.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: Thomas.Smith, alexis, berker.peksag, dstufft, haypo, ingy, merwok, refi64, tarek
Priority: normal Keywords:

Created on 2011-04-24 02:48 by ingy, last changed 2017-04-24 08:40 by berker.peksag. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 563 merged refi64, 2017-03-27 19:43
Messages (8)
msg134322 - (view) Author: Ingy dot Net (ingy) Date: 2011-04-24 02:48
When I upload modules to PyPI, distutils is clucking about a missing README, even though PyPI accepts README.rst, and I am providing that.

Registering pyplay to http://pypi.python.org/pypi
Server response (200): OK
python setup.py sdist upload
running sdist
warning: sdist: standard file not found: should have one of README, README.txt
msg134473 - (view) Author: Éric Araujo (merwok) * (Python committer) Date: 2011-04-26 15:41
If it’s only a warning, just ignore it.  This would be easy to fix, but as it would be considered a new feature, it can’t go into distutils, which is frozen.  I am however willing to edit the documentation to tell that PyPI will accept README.rst and that people need not worry about the unfortunate warning.  Would that be okay with you?

In distutils2, the replacement for distutils, we don’t included README by default.  I don’t know why this was changed.
msg143032 - (view) Author: resc (Thomas.Smith) Date: 2011-08-26 20:55
Just wanted to note that this confuses other people too...

http://stackoverflow.com/questions/4384796/readme-extension-for-python-projects

Is this something that could be changed in 'distribute'?
msg143151 - (view) Author: Éric Araujo (merwok) * (Python committer) Date: 2011-08-29 15:46
distribute is not a project of python-dev, please use their bug tracker.

For distutils, I explained why we can’t change it and proposed a doc change; nobody commented on that.

For distutils2, I’m waiting for a reply from Tarek to this question: why don’t we include README by default anymore?
msg144283 - (view) Author: Éric Araujo (merwok) * (Python committer) Date: 2011-09-19 14:58
> When I upload modules to PyPI, distutils is clucking about a missing
> README, even though PyPI accepts README.rst, and I am providing that.
PyPI doesn’t do anything with README, it displays the value of long_description.

> warning: sdist: standard file not found: should have one of README, README.txt
Is it a problem to name your reST file README.txt?


In packaging/distutils2, the recommended idiom looks like this (in setup.cfg):

    [metadata]
    description-file = README.whatever

sdist will include that file.  You can also write the description in the setup.cfg directly and have your README file included with the extra_files field.


This can’t be changed in distutils and works differently without warning in distutils2; closing.
msg290729 - (view) Author: Ryan Gonzalez (refi64) * Date: 2017-03-28 15:04
FWIW, I opened a PR for this: https://github.com/python/cpython/pull/563
msg291643 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2017-04-14 09:00
New changeset f9f87f0934ca570293ba7194bed3448a7f9bf39c by Victor Stinner (Ryan Gonzalez) in branch 'master':
bpo-11913: Add README.rst to the distutils standard READMEs list (#563)
https://github.com/python/cpython/commit/f9f87f0934ca570293ba7194bed3448a7f9bf39c
msg292206 - (view) Author: Berker Peksag (berker.peksag) * (Python committer) Date: 2017-04-24 08:40
PR 563 has been merged.
History
Date User Action Args
2017-04-24 08:40:11berker.peksagsetstatus: open -> closed

resolution: fixed

assignee: merwok ->
stage: needs patch -> resolved
versions: + Python 3.7
nosy: + berker.peksag, dstufft
messages: + msg292206
components: - Distutils2
type: behavior -> enhancement
2017-04-14 09:00:28hayposetnosy: + haypo
messages: + msg291643
2017-03-28 15:04:26refi64setnosy: + refi64
messages: + msg290729
2017-03-27 19:43:15refi64setpull_requests: + pull_request754
2017-03-27 17:54:29pitrousetstatus: closed -> open
resolution: wont fix -> (no value)
stage: resolved -> needs patch
2011-09-19 15:00:06merwoklinkissue12145 superseder
2011-09-19 14:58:36merwoksetstatus: open -> closed
messages: + msg144283

assignee: tarek -> merwok
resolution: wont fix
stage: resolved
2011-08-29 15:46:31merwoksettitle: sdist should allow for README.rst -> sdist refuses README.rst
nosy: + alexis

messages: + msg143151

components: + Distutils2
2011-08-26 20:55:25Thomas.Smithsetnosy: + Thomas.Smith
messages: + msg143032
2011-04-26 15:41:26merwoksetmessages: + msg134473
2011-04-24 02:48:42ingycreate